"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react2 = require("react");

var _react3 = _interopRequireDefault(_react2);

var _reactTransformHmr3 = require("react-transform-hmr");

var _reactTransformHmr4 = _interopRequireDefault(_reactTransformHmr3);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _jsonschema = require("jsonschema");

var _SchemaField2 = require("./fields/SchemaField");

var _SchemaField3 = _interopRequireDefault(_SchemaField2);

var _TitleField2 = require("./fields/TitleField");

var _TitleField3 = _interopRequireDefault(_TitleField2);

var _utils = require("../utils");

var _ErrorList = require("./ErrorList");

var _ErrorList2 = _interopRequireDefault(_ErrorList);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _components = {
  Form: {
    displayName: "Form"
  }
};

var _reactTransformHmr2 = (0, _reactTransformHmr4.default)({
  filename: "src/components/Form.js",
  components: _components,
  locals: [module],
  imports: [_react3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformHmr2(Component, id);
  };
}

var Form = _wrapComponent("Form")((_temp = _class = function (_Component) {
  _inherits(Form, _Component);

  function Form(props) {
    _classCallCheck(this, Form);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Form).call(this, props));

    _this.state = _this.getStateFromProps(props);
    // Caching bound instance methods for rendering perf optimization.
    _this._onChange = _this.onChange.bind(_this);
    _this._onSubmit = _this.onSubmit.bind(_this);
    return _this;
  }

  _createClass(Form, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      this.setState(this.getStateFromProps(nextProps));
    }
  }, {
    key: "getStateFromProps",
    value: function getStateFromProps(props) {
      var schema = "schema" in props ? props.schema : this.props.schema;
      var edit = !!props.formData;
      var definitions = schema.definitions;

      var formData = (0, _utils.getDefaultFormState)(schema, props.formData, definitions) || null;
      var errors = edit ? this.validate(formData, schema) : [];
      var errorSchema = (0, _utils.toErrorSchema)(errors);
      return { status: "initial", formData: formData, edit: edit, errors: errors, errorSchema: errorSchema };
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return (0, _utils.shouldRender)(this, nextProps, nextState);
    }
  }, {
    key: "validate",
    value: function validate(formData, schema) {
      var validator = new _jsonschema.Validator();
      return validator.validate(formData, schema || this.props.schema).errors;
    }
  }, {
    key: "renderErrors",
    value: function renderErrors() {
      var _state = this.state;
      var status = _state.status;
      var errors = _state.errors;

      if (status !== "editing" && errors.length) {
        return _react3.default.createElement(_ErrorList2.default, { errors: errors });
      }
      return null;
    }
  }, {
    key: "onChange",
    value: function onChange(formData) {
      var _this2 = this;

      var options = arguments.length <= 1 || arguments[1] === undefined ? { validate: true } : arguments[1];

      var errors = options.validate ? this.validate(formData) : this.state.errors;
      var errorSchema = (0, _utils.toErrorSchema)(errors);
      this.setState({
        status: "editing",
        formData: formData,
        errors: errors,
        errorSchema: errorSchema
      }, function (_) {
        if (_this2.props.onChange) {
          _this2.props.onChange(_this2.state);
        }
      });
    }
  }, {
    key: "onSubmit",
    value: function onSubmit(event) {
      var _this3 = this;

      event.preventDefault();
      this.setState({ status: "submitted" });
      var errors = this.validate(this.state.formData);
      if (Object.keys(errors).length > 0) {
        var errorSchema = (0, _utils.toErrorSchema)(errors);
        this.setState({ errors: errors, errorSchema: errorSchema }, function (_) {
          if (_this3.props.onError) {
            _this3.props.onError(errors);
          } else {
            console.error("Form validation failed", errors);
          }
        });
        return;
      } else if (this.props.onSubmit) {
        this.props.onSubmit(this.state);
      }
      this.setState({ status: "initial" });
    }
  }, {
    key: "getRegistry",
    value: function getRegistry() {
      // For BC, accept passed SchemaField and TitleField props and pass them to
      // the "fields" registry one.
      var _SchemaField = this.props.SchemaField || _SchemaField3.default;
      var _TitleField = this.props.TitleField || _TitleField3.default;
      var fields = Object.assign({
        SchemaField: _SchemaField,
        TitleField: _TitleField
      }, this.props.fields);
      return {
        fields: fields,
        widgets: this.props.widgets || {},
        definitions: this.props.schema.definitions || {}
      };
    }
  }, {
    key: "render",
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var schema = _props.schema;
      var uiSchema = _props.uiSchema;
      var _state2 = this.state;
      var formData = _state2.formData;
      var errorSchema = _state2.errorSchema;

      var registry = this.getRegistry();
      var _SchemaField = registry.fields.SchemaField;
      return _react3.default.createElement(
        "form",
        { className: "rjsf", onSubmit: this._onSubmit },
        this.renderErrors(),
        _react3.default.createElement(_SchemaField, {
          schema: schema,
          uiSchema: uiSchema,
          errorSchema: errorSchema,
          formData: formData,
          onChange: this._onChange,
          registry: registry }),
        children ? children : _react3.default.createElement(
          "p",
          null,
          _react3.default.createElement(
            "button",
            { type: "submit" },
            "Submit"
          )
        )
      );
    }
  }]);

  return Form;
}(_react2.Component), _class.defaultProps = {
  uiSchema: {}
}, _temp));

exports.default = Form;


if (process.env.NODE_ENV !== "production") {
  Form.propTypes = {
    schema: _react2.PropTypes.object.isRequired,
    uiSchema: _react2.PropTypes.object,
    formData: _react2.PropTypes.any,
    widgets: _react2.PropTypes.objectOf(_react2.PropTypes.func),
    fields: _react2.PropTypes.objectOf(_react2.PropTypes.func),
    onChange: _react2.PropTypes.func,
    onError: _react2.PropTypes.func,
    onSubmit: _react2.PropTypes.func
  };
}

exports.default = Form;