"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react2 = require("react");

var _react3 = _interopRequireDefault(_react2);

var _reactTransformHmr3 = require("react-transform-hmr");

var _reactTransformHmr4 = _interopRequireDefault(_reactTransformHmr3);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _utils = require("../../utils");

var _SelectWidget = require("./../widgets/SelectWidget");

var _SelectWidget2 = _interopRequireDefault(_SelectWidget);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _components = {
  ArrayField: {
    displayName: "ArrayField"
  }
};

var _reactTransformHmr2 = (0, _reactTransformHmr4.default)({
  filename: "src/components/fields/ArrayField.js",
  components: _components,
  locals: [module],
  imports: [_react3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformHmr2(Component, id);
  };
}

var ArrayField = _wrapComponent("ArrayField")((_temp = _class = function (_Component) {
  _inherits(ArrayField, _Component);

  function ArrayField(props) {
    _classCallCheck(this, ArrayField);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ArrayField).call(this, props));

    _this.state = _this.getStateFromProps(props);
    // Caching bound instance methods for rendering perf optimization.
    _this._onSelectChange = _this.onSelectChange.bind(_this);
    _this._onChange = _this.onChange.bind(_this);
    _this._onChangeForIndex = function (index) {
      return _this._onChange.bind(_this, index);
    };
    _this._onDropClick = _this.onDropClick.bind(_this);
    _this._onDropIndexClick = function (index) {
      return _this._onDropClick.bind(_this, index);
    };
    _this._onAddClick = _this.onAddClick.bind(_this);
    return _this;
  }

  _createClass(ArrayField, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      this.setState(this.getStateFromProps(nextProps));
    }
  }, {
    key: "getStateFromProps",
    value: function getStateFromProps(props) {
      var formData = Array.isArray(props.formData) ? props.formData : null;
      var definitions = this.props.registry.definitions;

      return {
        items: (0, _utils.getDefaultFormState)(props.schema, formData, definitions) || []
      };
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return (0, _utils.shouldRender)(this, nextProps, nextState);
    }
  }, {
    key: "isItemRequired",
    value: function isItemRequired(itemsSchema) {
      return itemsSchema.type === "string" && itemsSchema.minLength > 0;
    }
  }, {
    key: "asyncSetState",
    value: function asyncSetState(state, options) {
      var _this2 = this;

      // ensure state is propagated to parent component when it's actually set
      this.setState(state, function (_) {
        return _this2.props.onChange(_this2.state.items, options);
      });
    }
  }, {
    key: "onAddClick",
    value: function onAddClick(event) {
      event.preventDefault();
      var items = this.state.items;
      var _props = this.props;
      var schema = _props.schema;
      var registry = _props.registry;
      var definitions = registry.definitions;

      this.asyncSetState({
        items: items.concat((0, _utils.getDefaultFormState)(schema.items, undefined, definitions))
      }, { validate: false });
    }
  }, {
    key: "onDropClick",
    value: function onDropClick(index, event) {
      event.preventDefault();
      this.asyncSetState({
        items: this.state.items.filter(function (_, i) {
          return i !== index;
        })
      }, { validate: false });
    }
  }, {
    key: "onChange",
    value: function onChange(index, value) {
      this.asyncSetState({
        items: this.state.items.map(function (item, i) {
          return index === i ? value : item;
        })
      }, { validate: false });
    }
  }, {
    key: "onSelectChange",
    value: function onSelectChange(value) {
      this.asyncSetState({ items: value }, { validate: false });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _props2 = this.props;
      var schema = _props2.schema;
      var uiSchema = _props2.uiSchema;
      var errorSchema = _props2.errorSchema;
      var name = _props2.name;

      var title = schema.title || name;
      var items = this.state.items;
      var _props$registry = this.props.registry;
      var fields = _props$registry.fields;
      var definitions = _props$registry.definitions;
      var SchemaField = fields.SchemaField;

      var itemsSchema = (0, _utils.retrieveSchema)(schema.items, definitions);
      if ((0, _utils.isMultiSelect)(schema)) {
        return _react3.default.createElement(_SelectWidget2.default, {
          multiple: true,
          onChange: this._onSelectChange,
          options: (0, _utils.optionsList)(itemsSchema),
          schema: schema,
          title: title,
          defaultValue: schema.default,
          value: items
        });
      }

      return _react3.default.createElement(
        "fieldset",
        {
          className: "field field-array field-array-of-" + itemsSchema.type },
        title ? _react3.default.createElement(
          "legend",
          null,
          title
        ) : null,
        schema.description ? _react3.default.createElement(
          "div",
          { className: "field-description" },
          schema.description
        ) : null,
        _react3.default.createElement(
          "div",
          { className: "array-item-list" },
          items.map(function (item, index) {
            var itemErrorSchema = errorSchema ? errorSchema[index] : undefined;
            return _react3.default.createElement(
              "div",
              { key: index },
              _react3.default.createElement(SchemaField, {
                schema: itemsSchema,
                uiSchema: uiSchema.items,
                formData: items[index],
                errorSchema: itemErrorSchema,
                required: _this3.isItemRequired(itemsSchema),
                onChange: _this3._onChangeForIndex(index),
                registry: _this3.props.registry }),
              _react3.default.createElement(
                "p",
                { className: "array-item-remove" },
                _react3.default.createElement(
                  "button",
                  { type: "button",
                    onClick: _this3._onDropIndexClick(index) },
                  "-"
                )
              )
            );
          })
        ),
        _react3.default.createElement(
          "p",
          { className: "array-item-add" },
          _react3.default.createElement(
            "button",
            { type: "button", onClick: this._onAddClick },
            "+"
          )
        )
      );
    }
  }, {
    key: "itemTitle",
    get: function get() {
      var schema = this.props.schema;

      return schema.items.title || schema.items.description || "Item";
    }
  }]);

  return ArrayField;
}(_react2.Component), _class.defaultProps = {
  uiSchema: {}
}, _temp));

if (process.env.NODE_ENV !== "production") {
  ArrayField.propTypes = {
    schema: _react2.PropTypes.object.isRequired,
    uiSchema: _react2.PropTypes.object,
    errorSchema: _react2.PropTypes.object,
    onChange: _react2.PropTypes.func.isRequired,
    formData: _react2.PropTypes.array,
    registry: _react2.PropTypes.shape({
      widgets: _react2.PropTypes.objectOf(_react2.PropTypes.func).isRequired,
      fields: _react2.PropTypes.objectOf(_react2.PropTypes.func).isRequired
    })
  };
}

exports.default = ArrayField;