"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react2 = require("react");

var _react3 = _interopRequireDefault(_react2);

var _reactTransformHmr3 = require("react-transform-hmr");

var _reactTransformHmr4 = _interopRequireDefault(_reactTransformHmr3);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _utils = require("../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _components = {
  ObjectField: {
    displayName: "ObjectField"
  }
};

var _reactTransformHmr2 = (0, _reactTransformHmr4.default)({
  filename: "src/components/fields/ObjectField.js",
  components: _components,
  locals: [module],
  imports: [_react3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformHmr2(Component, id);
  };
}

var ObjectField = _wrapComponent("ObjectField")((_temp = _class = function (_Component) {
  _inherits(ObjectField, _Component);

  function ObjectField(props) {
    _classCallCheck(this, ObjectField);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ObjectField).call(this, props));

    _this.state = _this.getStateFromProps(props);
    // Caching bound instance methods for rendering perf optimization.
    _this._onChange = _this.onChange.bind(_this);
    _this._onPropertyChange = function (name) {
      return _this._onChange.bind(_this, name);
    };
    return _this;
  }

  _createClass(ObjectField, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      this.setState(this.getStateFromProps(nextProps));
    }
  }, {
    key: "getStateFromProps",
    value: function getStateFromProps(props) {
      var schema = props.schema;
      var formData = props.formData;
      var registry = props.registry;

      return (0, _utils.getDefaultFormState)(schema, formData, registry.definitions) || {};
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return (0, _utils.shouldRender)(this, nextProps, nextState);
    }
  }, {
    key: "isRequired",
    value: function isRequired(name) {
      var schema = this.props.schema;
      return Array.isArray(schema.required) && schema.required.indexOf(name) !== -1;
    }
  }, {
    key: "asyncSetState",
    value: function asyncSetState(state) {
      var _this2 = this;

      // ensure state is propagated to parent component when it's actually set
      this.setState(state, function (_) {
        return _this2.props.onChange(_this2.state);
      });
    }
  }, {
    key: "onChange",
    value: function onChange(name, value) {
      this.asyncSetState(_defineProperty({}, name, value));
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _props = this.props;
      var uiSchema = _props.uiSchema;
      var errorSchema = _props.errorSchema;
      var name = _props.name;
      var _props$registry = this.props.registry;
      var definitions = _props$registry.definitions;
      var fields = _props$registry.fields;
      var SchemaField = fields.SchemaField;
      var TitleField = fields.TitleField;

      var schema = (0, _utils.retrieveSchema)(this.props.schema, definitions);
      var title = schema.title || name;
      var orderedProperties = void 0;
      try {
        var properties = Object.keys(schema.properties);
        orderedProperties = (0, _utils.orderProperties)(properties, uiSchema["ui:order"]);
      } catch (err) {
        return _react3.default.createElement(
          "div",
          null,
          _react3.default.createElement(
            "p",
            { className: "config-error", style: { color: "red" } },
            "Invalid ",
            name || "root",
            " object field configuration:",
            _react3.default.createElement(
              "em",
              null,
              err.message
            ),
            "."
          ),
          _react3.default.createElement(
            "pre",
            null,
            JSON.stringify(schema)
          )
        );
      }
      return _react3.default.createElement(
        "fieldset",
        null,
        title ? _react3.default.createElement(TitleField, { title: title }) : null,
        schema.description ? _react3.default.createElement(
          "div",
          { className: "field-description" },
          schema.description
        ) : null,
        orderedProperties.map(function (name, index) {
          return _react3.default.createElement(SchemaField, { key: index,
            name: name,
            required: _this3.isRequired(name),
            schema: schema.properties[name],
            uiSchema: uiSchema[name],
            errorSchema: errorSchema[name],
            formData: _this3.state[name],
            onChange: _this3._onPropertyChange(name),
            registry: _this3.props.registry });
        })
      );
    }
  }]);

  return ObjectField;
}(_react2.Component), _class.defaultProps = {
  uiSchema: {},
  errorSchema: {}
}, _temp));

if (process.env.NODE_ENV !== "production") {
  ObjectField.propTypes = {
    schema: _react2.PropTypes.object.isRequired,
    uiSchema: _react2.PropTypes.object,
    onChange: _react2.PropTypes.func.isRequired,
    formData: _react2.PropTypes.object,
    required: _react2.PropTypes.bool,
    registry: _react2.PropTypes.shape({
      widgets: _react2.PropTypes.objectOf(_react2.PropTypes.func).isRequired,
      fields: _react2.PropTypes.objectOf(_react2.PropTypes.func).isRequired
    })
  };
}

exports.default = ObjectField;